﻿using System.Collections.Generic;
using Newtonsoft.Json;

namespace Jsdl.Domain
{
	public class ServiceType
	{
		[JsonProperty(PropertyName = "name")]
		public string Name { get; set; }

		[JsonProperty(PropertyName = "format")]
		public string Format { get; set; }

		[JsonProperty(PropertyName = "type")]
		public string TypeRaw { get; set; }

		[JsonIgnore]
		public string Type
		{
			get { return TypeRaw ?? "object"; }
		}
		
		[JsonProperty(PropertyName = "description")]
		public string Description { get; set; }

		[JsonIgnore]
		public virtual bool Required // default = false
		{
			get { return RequiredRaw.HasValue && RequiredRaw.Value; }
		}

		[JsonProperty(PropertyName = "required")]
		public bool? RequiredRaw { get; set; }


		[JsonProperty(PropertyName = "properties")]
		public Dictionary<string, ServiceType> Properties { get; set; }

		[JsonProperty(PropertyName = "items")]
		public ServiceType Items { get; set; }
	}
}